/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from wlr-output-management-unstable-v1.xml by mir_wayland_generator
 */

#ifndef MIR_FRONTEND_WAYLAND_WLR_OUTPUT_MANAGEMENT_UNSTABLE_V1_XML_WRAPPER
#define MIR_FRONTEND_WAYLAND_WLR_OUTPUT_MANAGEMENT_UNSTABLE_V1_XML_WRAPPER

#include <optional>

#include "mir/fd.h"
#include <wayland-server-core.h>

#include "mir/wayland/global.h"
#include "mir/wayland/resource.h"

namespace mir
{
namespace wayland
{

    class OutputManagerV1;
    class OutputHeadV1;
    class OutputModeV1;
    class OutputConfigurationV1;
    class OutputConfigurationHeadV1;

    class OutputManagerV1 : public Resource
    {
    public:
        static char const constexpr* interface_name = "zwlr_output_manager_v1";

        static OutputManagerV1* from(struct wl_resource*);

        OutputManagerV1(struct wl_resource* resource, Version<4>);
        virtual ~OutputManagerV1();

        void send_head_event(struct wl_resource* head) const;
        void send_done_event(uint32_t serial) const;
        void send_finished_event() const;

        void destroy_and_delete() const;

        struct Opcode
        {
            static uint32_t const head = 0;
            static uint32_t const done = 1;
            static uint32_t const finished = 2;
        };

        struct Thunks;

        static bool is_instance(wl_resource* resource);

        class Global : public wayland::Global
        {
        public:
            Global(wl_display* display, Version<4>);

            auto interface_name() const -> char const* override;

        private:
            virtual void bind(wl_resource* new_zwlr_output_manager_v1) = 0;
            friend OutputManagerV1::Thunks;
        };

    private:
        virtual void create_configuration(struct wl_resource* id, uint32_t serial) = 0;
        virtual void stop() = 0;
    };

    class OutputHeadV1 : public Resource
    {
    public:
        static char const constexpr* interface_name = "zwlr_output_head_v1";

        static OutputHeadV1* from(struct wl_resource*);

        OutputHeadV1(OutputManagerV1 const& parent);
        virtual ~OutputHeadV1();

        void send_name_event(std::string const& name) const;
        void send_description_event(std::string const& description) const;
        void send_physical_size_event(int32_t width, int32_t height) const;
        void send_mode_event(struct wl_resource* mode) const;
        void send_enabled_event(int32_t enabled) const;
        void send_current_mode_event(struct wl_resource* mode) const;
        void send_position_event(int32_t x, int32_t y) const;
        void send_transform_event(int32_t transform) const;
        void send_scale_event(double scale) const;
        void send_finished_event() const;
        bool version_supports_make();
        void send_make_event_if_supported(std::string const& make) const;
        void send_make_event(std::string const& make) const;
        bool version_supports_model();
        void send_model_event_if_supported(std::string const& model) const;
        void send_model_event(std::string const& model) const;
        bool version_supports_serial_number();
        void send_serial_number_event_if_supported(std::string const& serial_number) const;
        void send_serial_number_event(std::string const& serial_number) const;
        bool version_supports_adaptive_sync();
        void send_adaptive_sync_event_if_supported(uint32_t state) const;
        void send_adaptive_sync_event(uint32_t state) const;

        struct AdaptiveSyncState
        {
            static uint32_t const disabled = 0;
            static uint32_t const enabled = 1;
        };

        struct Opcode
        {
            static uint32_t const name = 0;
            static uint32_t const description = 1;
            static uint32_t const physical_size = 2;
            static uint32_t const mode = 3;
            static uint32_t const enabled = 4;
            static uint32_t const current_mode = 5;
            static uint32_t const position = 6;
            static uint32_t const transform = 7;
            static uint32_t const scale = 8;
            static uint32_t const finished = 9;
            static uint32_t const make = 10;
            static uint32_t const model = 11;
            static uint32_t const serial_number = 12;
            static uint32_t const adaptive_sync = 13;
        };

        struct Thunks;

        static bool is_instance(wl_resource* resource);

    private:
        virtual void release() { }
    };

    class OutputModeV1 : public Resource
    {
    public:
        static char const constexpr* interface_name = "zwlr_output_mode_v1";

        static OutputModeV1* from(struct wl_resource*);

        OutputModeV1(OutputHeadV1 const& parent);
        virtual ~OutputModeV1();

        void send_size_event(int32_t width, int32_t height) const;
        void send_refresh_event(int32_t refresh) const;
        void send_preferred_event() const;
        void send_finished_event() const;

        struct Opcode
        {
            static uint32_t const size = 0;
            static uint32_t const refresh = 1;
            static uint32_t const preferred = 2;
            static uint32_t const finished = 3;
        };

        struct Thunks;

        static bool is_instance(wl_resource* resource);

    private:
        virtual void release() { }
    };

    class OutputConfigurationV1 : public Resource
    {
    public:
        static char const constexpr* interface_name = "zwlr_output_configuration_v1";

        static OutputConfigurationV1* from(struct wl_resource*);

        OutputConfigurationV1(struct wl_resource* resource, Version<4>);
        virtual ~OutputConfigurationV1();

        void send_succeeded_event() const;
        void send_failed_event() const;
        void send_cancelled_event() const;

        struct Error
        {
            static uint32_t const already_configured_head = 1;
            static uint32_t const unconfigured_head = 2;
            static uint32_t const already_used = 3;
        };

        struct Opcode
        {
            static uint32_t const succeeded = 0;
            static uint32_t const failed = 1;
            static uint32_t const cancelled = 2;
        };

        struct Thunks;

        static bool is_instance(wl_resource* resource);

    private:
        virtual void enable_head(struct wl_resource* id, struct wl_resource* head) = 0;
        virtual void disable_head(struct wl_resource* head) = 0;
        virtual void apply() = 0;
        virtual void test() = 0;
        virtual void destroy() { }
    };

    class OutputConfigurationHeadV1 : public Resource
    {
    public:
        static char const constexpr* interface_name = "zwlr_output_configuration_head_v1";

        static OutputConfigurationHeadV1* from(struct wl_resource*);

        OutputConfigurationHeadV1(struct wl_resource* resource, Version<4>);
        virtual ~OutputConfigurationHeadV1();

        void destroy_and_delete() const;

        struct Error
        {
            static uint32_t const already_set = 1;
            static uint32_t const invalid_mode = 2;
            static uint32_t const invalid_custom_mode = 3;
            static uint32_t const invalid_transform = 4;
            static uint32_t const invalid_scale = 5;
            static uint32_t const invalid_adaptive_sync_state = 6;
        };

        struct Thunks;

        static bool is_instance(wl_resource* resource);

    private:
        virtual void set_mode(struct wl_resource* mode) = 0;
        virtual void set_custom_mode(int32_t width, int32_t height, int32_t refresh) = 0;
        virtual void set_position(int32_t x, int32_t y) = 0;
        virtual void set_transform(int32_t transform) = 0;
        virtual void set_scale(double scale) = 0;
        virtual void set_adaptive_sync(uint32_t state) = 0;
    };

}
}

#endif // MIR_FRONTEND_WAYLAND_WLR_OUTPUT_MANAGEMENT_UNSTABLE_V1_XML_WRAPPER
